# -*- coding: utf-8 -*-
"""AddToCartCron.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1-gugilShfn0ccMw_XACOCaENcx6r-D2b
"""


from sqlalchemy import create_engine
import pandas as pd
engine = create_engine("mysql+pymysql://tuadmin:Turant123@turantdb-instance.cdvlyair641e.ap-south-1.rds.amazonaws.com""/turant")
connn = engine.connect()

"""yeterday trending"""

trendy= pd.read_sql("""SELECT * FROM (SELECT storeid,productid,count(storeid) as count FROM (SELECT REPLACE(SUBSTRING_INDEX(SUBSTRING_INDEX(event_parameters, "'Product_ID':", -1),", 'Store_ID':",1),"}","") as productid,
REPLACE(REPLACE(LEFT(SUBSTRING_INDEX(event_parameters, "'Store_ID':", -1),3),",",""),"'","") as storeid FROM stepuplogs.audit_trails 
where event_name='Click_AddToCart'
and created_on > curdate() - interval 1 day) AS A
group by storeid,productid) AS B
order by count desc;""",con=connn)

"""trending in last 7 days"""

trendw= pd.read_sql("""SELECT * FROM (SELECT storeid,productid,count(storeid) as count FROM (SELECT REPLACE(SUBSTRING_INDEX(SUBSTRING_INDEX(event_parameters, "'Product_ID':", -1),", 'Store_ID':",1),"}","") as productid,
REPLACE(REPLACE(LEFT(SUBSTRING_INDEX(event_parameters, "'Store_ID':", -1),3),",",""),"'","") as storeid FROM stepuplogs.audit_trails 
where event_name='Click_AddToCart'
and created_on > curdate() - interval 7 day) AS A
group by storeid,productid) AS B
order by count desc;""",con=connn)

"""Trending in last 30 days"""

trendm= pd.read_sql("""SELECT * FROM (SELECT storeid,productid,count(storeid) as count FROM (SELECT REPLACE(SUBSTRING_INDEX(SUBSTRING_INDEX(event_parameters, "'Product_ID':", -1),", 'Store_ID':",1),"}","") as productid,
REPLACE(REPLACE(LEFT(SUBSTRING_INDEX(event_parameters, "'Store_ID':", -1),3),",",""),"'","") as storeid FROM stepuplogs.audit_trails 
where event_name='Click_AddToCart'
and created_on > curdate() - interval 30 day) AS A
group by storeid,productid) AS B
order by count desc;""",con=connn)

"""Trending all time"""

trenda= pd.read_sql("""SELECT * FROM (SELECT storeid,productid,count(storeid) as count FROM (SELECT REPLACE(SUBSTRING_INDEX(SUBSTRING_INDEX(event_parameters, "'Product_ID':", -1),", 'Store_ID':",1),"}","") as productid,
REPLACE(REPLACE(LEFT(SUBSTRING_INDEX(event_parameters, "'Store_ID':", -1),3),",",""),"'","") as storeid FROM stepuplogs.audit_trails 
where event_name='Click_AddToCart') AS A
group by storeid,productid) AS B
order by count desc;""",con=connn)

trenda.columns=['storeid', 'productid', 'lifetimecount']
trendm.columns=['storeid', 'productid', 'monthcount']
trendw.columns=['storeid', 'productid', 'weekcount']
trendy.columns=['storeid', 'productid', 'daycount']

trendproduct= trenda.merge(trendm,left_on=['storeid', 'productid'],right_on=['storeid', 'productid'],how='left').merge(trendw,left_on=['storeid', 'productid'],right_on=['storeid', 'productid'],how='left').merge(trendy,left_on=['storeid', 'productid'],right_on=['storeid', 'productid'],how='left')

# Python program to get
# Yesterday's date


# Import date and timedelta class
# from datetime module
from datetime import date
from datetime import timedelta

# Get today's date
today = date.today()
print("Today is: ", today)

trendproduct['date']=today

engine = create_engine("mysql+pymysql://tuadmin:Turant123@turantdb-instance.cdvlyair641e.ap-south-1.rds.amazonaws.com/stepupstats")
conn = engine.connect()

# # Read
# qwe = pd.read_sql('select * from users;', con=con) 
#print(yesterday_record)
# # Create new Table
trendproduct.to_sql(con=conn, name='addtocarttrend', if_exists='replace')

conn.close()